clc
clear all
close all

metodo = 'zoh'
Ts = 0.3


polos = [-1-i  -1+i]
ceros = []
x0 = [0 0] 

% Armo los polinomios de Numerador y Denominador
NUMc = poly(ceros);
DENc = poly(polos);

% Armo transferencia en Laplace del Sistema
Tc = tf(NUMc,DENc)

% Hallo la reprensentacion de la transferencia del Sistema en Variables de estado.
sysVEc = ss(Tc)

% Discretizo el Sistema en VE
sysVEd = c2d(sysVEc,Ts,metodo)

% Discretizo el sistema en transferencia
Td = c2d(Tc,Ts,metodo)

%% Algoritmo
T = idpoly(Td)
b = T.b
a = T.f

u = ones(1,100);
y = zeros(size(u));

Y = [0  0];  % Y = [yk_1  yk_2]
U = [0 0] ;   % U = [uk_1  uk_2] 
for i=1:length(u)
    
    
    yk_1 = Y(1);
    yk_2 = Y(2);
    
    uk = u(i);
    uk_1 = u(1);
    uk_2 = u(2);
    
    % Ecuacion en recurrencia
    yk = -a(2)*yk_1 -a(3)*yk_2 + b(1)*uk + b(2)*uk_1 + b(3)*uk_2;
    y(i) = yk;
    
    % Actualizo memorias
    Y = [yk Y(1:end-1)];
    U = [uk U(1:end-1)];
    
    
end    
    
figure; hold on
stem([1:length(y)]*Ts,y)
plot(yt.time,yt.signals.values,'r')
 